/*
 * StandAloneJavaClient.java
 *
 * Created on March 8, 2007, 9:41 AM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package enterprise.lottery_annotation_client;

import javax.naming.InitialContext;
import javax.ejb.EJB;

import enterprise.lottery_annotation_ejb_stateful.Lottery;
import enterprise.lottery_annotation_ejb_stateless.Dice;

public class StandAloneJavaClient {    
    
    private static final String namingFactoryKeyName="java.naming.factory.initial";
    private static final String namingFactoryKeyValue="com.sun.appserv.naming.S1ASCtxFactory";
    private static final String lbPolicyKeyName="com.sun.appserv.iiop.loadbalancingpolicy";
    private static String lbPolicyKeyValue="ic-based";
    private static final String endpointsKeyName="com.sun.appserv.iiop.endpoints";
    private static String endpointsKeyValue="";
    private static java.util.Properties properties=null;
    
    private static void usage(){
        System.out.println("Usage: java $vmargs -cp $CP enterprise.lottery_annotation_client.StandAloneJavaClient typeoftest iiopendpoints");
    }
    
    public static void main(String args[]) {
        
        if(args==null || args.length < 2){
            usage();
            System.exit(0);
        }
        
        properties=new java.util.Properties();
        
        endpointsKeyValue = args[1];
        
        if(args.length>2){
            lbPolicyKeyValue=args[2];
        }
        StandAloneJavaClient client = new StandAloneJavaClient();    
        properties.put(namingFactoryKeyName, namingFactoryKeyValue);
        properties.put(lbPolicyKeyName, lbPolicyKeyValue);
        properties.put(endpointsKeyName, endpointsKeyValue);
        System.out.println("Properties "+ properties.toString());
        
        if("FailOver".equalsIgnoreCase(args[0])){
            System.out.println("Running the failover test!");
            client.foTest();
        }else if("LB".equalsIgnoreCase(args[0])){
            System.out.println("Running the lb test!");
            client.lbTest();
        }else if("LB2".equalsIgnoreCase(args[0])){
            System.out.println("Running the lb test2!");
            client.lbTest2();
        }else if("FO2".equalsIgnoreCase(args[0])){
            System.out.println("Running the failover test2!");
            client.foTest2();
        }else if("DynamicLBTest".equalsIgnoreCase(args[0])){
            System.out.println("Running the dynamic lb tests!");
            client.lbTest2();
            client.waitForEnter();
            client.lbTest2();
        }
        
    }
    
    public StandAloneJavaClient(){}
    
    public void lbTest(){
        InitialContext ic = null;        
        for(int j = 0 ; j < 2; j++){            
            try {
                ic = new InitialContext(properties);
                System.out.println("IC :"+ic.getEnvironment().toString());
                Lottery lottery1 =
                        (Lottery) ic.lookup("enterprise.lottery_annotation_ejb_stateful.Lottery");
                lottery1.setName("Super Stinker");
                Dice dice1;
                for(int i=0; i<6; i++) {
                    dice1 =
                            (Dice) ic.lookup("enterprise.lottery_annotation_ejb_stateless.Dice");
                    lottery1.select(dice1.play());
                }
                
                String lotteryName = lottery1.getName();
                String lotteryNumber = lottery1.getNumber();
                String lotteryDate = lottery1.getDate();
                String results = "Your" + " " + lotteryName + " " +
                        "quick pick, played on" + " " + lotteryDate +
                        " " + "is" + " " + lotteryNumber;
                System.out.println(results);
                ic.close();
                ic=null;
                lottery1=null;
                dice1=null;
            } catch(Exception e) {
                System.out.println("Exception: " + e);
                e.printStackTrace();
            }
        }
    }
    
    public void lbTest2(){
        InitialContext ic = null;
        for(int j = 0 ; j < 100; j++){
            
            try {
                ic = new InitialContext(properties);
                Lottery lottery1 =
                        (Lottery) ic.lookup("enterprise.lottery_annotation_ejb_stateful.Lottery");
                lottery1.setName("Super Stinker");
                Dice dice1;
                for(int i=0; i<6; i++) {
                    dice1 =
                            (Dice) ic.lookup("enterprise.lottery_annotation_ejb_stateless.Dice");
                    lottery1.select(dice1.play());
                }
                
                String lotteryName = lottery1.getName();
                String lotteryNumber = lottery1.getNumber();
                String lotteryDate = lottery1.getDate();
                String results = "Your" + " " + lotteryName + " " +
                        "quick pick, played on" + " " + lotteryDate +
                        " " + "is" + " " + lotteryNumber;
                System.out.println(results);
                ic.close();
                ic=null;
                lottery1=null;
                dice1=null;
                
                if(j==20){
                    waitForEnter();
                }
                
                if(j==40){
                    waitForEnter();
                }
            } catch(Exception e) {
                System.out.println("Exception: " + e);
                e.printStackTrace();
            }
        }
    }
    
    /*public void lbTest(){
        try {
            for(int i=0; i<600; i++) {
                lottery.select(dice.play());
                String lotteryName = lottery.getName();
                String lotteryNumber = lottery.getNumber();
                String lotteryDate = lottery.getDate();
                String results = "Your" + " " + lotteryName + " " +
                        "quick pick, played on" + " " + lotteryDate +
                        " " + "is" + " " + lotteryNumber;
                System.out.println(results);
            }
        } catch(Exception e) {
            System.out.println("Exception: " + e);
            e.printStackTrace();
        }
    }*/
    
    public void foTest(){
        InitialContext ic = null;
        Lottery lottery=null;
        Dice dice=null;
        try{
            ic = new InitialContext(properties);
            lottery=(Lottery) ic.lookup("enterprise.lottery_annotation_ejb_stateful.Lottery");
            dice=(Dice) ic.lookup("enterprise.lottery_annotation_ejb_stateless.Dice");
        }catch(Exception ex){
            ex.printStackTrace();
        }
        for(int j = 0 ; j < 1000; j++){
            try {
                for(int i=0; i<6; i++) {
                    lottery.select(dice.play());
                }
                String lotteryName = lottery.getName();
                String lotteryNumber = lottery.getNumber();
                String lotteryDate = lottery.getDate();
                
                String results = "Your" + " " + lotteryName + " " +
                        "quick pick, played on" + " " + lotteryDate +
                        " " + "is" + " " + lotteryNumber;
                
                System.out.println(results);
                Thread.sleep(600);
            } catch(Exception e) {
                System.out.println("Exception: " + e);
                e.printStackTrace();
            }
        }
    }
    
    public void foTest2(){
        InitialContext ic = null;
        try{
            ic = new InitialContext(properties);
        }catch(Exception ex){
            ex.printStackTrace();
        }        
        waitForEnter();
        for(int j = 0 ; j < 100; j++){            
            try {                
                Lottery lottery1 =
                        (Lottery) ic.lookup("enterprise.lottery_annotation_ejb_stateful.Lottery");
                lottery1.setName("Super Stinker");
                Dice dice1;
                for(int i=0; i<6; i++) {
                    dice1 =
                            (Dice) ic.lookup("enterprise.lottery_annotation_ejb_stateless.Dice");
                    lottery1.select(dice1.play());
                }
                
                String lotteryName = lottery1.getName();
                String lotteryNumber = lottery1.getNumber();
                String lotteryDate = lottery1.getDate();
                String results = "Your" + " " + lotteryName + " " +
                        "quick pick, played on" + " " + lotteryDate +
                        " " + "is" + " " + lotteryNumber;
                System.out.println(results);
                ic.close();
                ic=null;
                lottery1=null;
                dice1=null;
                
                if(j==50){
                    waitForEnter();
                }   
                ic = new InitialContext(properties);
            } catch(Exception e) {
                System.out.println("Exception: " + e);
                e.printStackTrace();
            }
        }
    }
    
    private  static void waitForEnter(){
        try{
            System.out.println("Press <Enter> to continue ...");
            java.io.BufferedReader reader = new java.io.BufferedReader(new java.io.InputStreamReader(System.in));
            reader.readLine();
        } catch(Exception e){
            System.out.println("Exception while waiting for <Enter>:"+e.toString());
        }
    }
}

